import { Expression, EngineOptions } from './types';
import { JsonTemplateLexer } from './lexer';
export declare class JsonTemplateParser {
    private lexer;
    private options?;
    constructor(lexer: JsonTemplateLexer, options?: EngineOptions);
    parse(): Expression;
    private parseEndOfStatement;
    private parseStatements;
    private parseStatementsExpr;
    private parseStatementExpr;
    private parseAssignmentExpr;
    private parseBaseExpr;
    private parseNextExpr;
    private parsePathPart;
    private parsePathParts;
    private parseContextVariable;
    private parsePathOptions;
    private parsePathRoot;
    private parsePathType;
    private parsePath;
    private createArrayIndexFilterExpr;
    private createArrayFilterExpr;
    private parseSelector;
    private parseRangeFilterExpr;
    private parseArrayIndexFilterExpr;
    private parseArrayFilter;
    private parseObjectFilter;
    private parseObjectFiltersExpr;
    private parseConditionalExpr;
    private parseArrayFilterExpr;
    private combineExpressionsAsBinaryExpr;
    private parseArrayCoalesceExpr;
    private parseCoalesceExpr;
    private parseLogicalORExpr;
    private parseLogicalANDExpr;
    private parseEqualityExpr;
    private parseRelationalExpr;
    private parseShiftExpr;
    private parseAdditiveExpr;
    private parseMultiplicativeExpr;
    private parsePowerExpr;
    private parseUnaryExpr;
    private shouldSkipPathParsing;
    private parsePathAfterExpr;
    private createLiteralExpr;
    private parseLiteralExpr;
    private parseIDPath;
    private parseObjectDefVars;
    private parseNormalDefVars;
    private parseDefinitionExpr;
    private parseFunctionCallArgs;
    private parseFunctionCallExpr;
    private parseFunctionDefinitionParam;
    private parseFunctionDefinitionParams;
    private parseFunctionExpr;
    private parseObjectKeyExpr;
    private parseObjectPropExpr;
    private parseObjectExpr;
    private parseCommaSeparatedElements;
    private parseSpreadExpr;
    private parseArrayExpr;
    private parseBlockExpr;
    private parseAsyncFunctionExpr;
    private parseLambdaExpr;
    private parseCompileTimeBaseExpr;
    private parseCompileTimeExpr;
    private parseNumber;
    private parseFloatingNumber;
    private parseKeywordBasedExpr;
    private parsePrimaryExpr;
    private static pathContainsVariables;
    private static convertToBlockExpr;
    private static prependFunctionID;
    private static ignoreEmptySelectors;
    private static combinePathOptionParts;
    private static convertToFunctionCallExpr;
    private static isArrayFilterExpressionSimple;
    private static isSimplePathPart;
    private static isSimplePath;
    private static isRichPath;
    private static updatePathExpr;
    private static parseBaseExprFromTemplate;
}
//# sourceMappingURL=parser.d.ts.map