"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PathType = exports.SyntaxType = exports.OperatorType = exports.TokenType = exports.Keyword = void 0;
var Keyword;
(function (Keyword) {
    Keyword["FUNCTION"] = "function";
    Keyword["NEW"] = "new";
    Keyword["TYPEOF"] = "typeof";
    Keyword["LET"] = "let";
    Keyword["CONST"] = "const";
    Keyword["LAMBDA"] = "lambda";
    Keyword["AWAIT"] = "await";
    Keyword["ASYNC"] = "async";
    Keyword["IN"] = "in";
})(Keyword = exports.Keyword || (exports.Keyword = {}));
var TokenType;
(function (TokenType) {
    TokenType[TokenType["UNKNOWN"] = 0] = "UNKNOWN";
    TokenType[TokenType["ID"] = 1] = "ID";
    TokenType[TokenType["INT"] = 2] = "INT";
    TokenType[TokenType["FLOAT"] = 3] = "FLOAT";
    TokenType[TokenType["STR"] = 4] = "STR";
    TokenType[TokenType["BOOL"] = 5] = "BOOL";
    TokenType[TokenType["NULL"] = 6] = "NULL";
    TokenType[TokenType["UNDEFINED"] = 7] = "UNDEFINED";
    TokenType[TokenType["LAMBDA_ARG"] = 8] = "LAMBDA_ARG";
    TokenType[TokenType["PUNCT"] = 9] = "PUNCT";
    TokenType[TokenType["THROW"] = 10] = "THROW";
    TokenType[TokenType["KEYWORD"] = 11] = "KEYWORD";
    TokenType[TokenType["EOT"] = 12] = "EOT";
})(TokenType = exports.TokenType || (exports.TokenType = {}));
// In the order of precedence
var OperatorType;
(function (OperatorType) {
    OperatorType[OperatorType["BASE"] = 0] = "BASE";
    OperatorType[OperatorType["CONDITIONAL"] = 1] = "CONDITIONAL";
    OperatorType[OperatorType["ASSIGNMENT"] = 2] = "ASSIGNMENT";
    OperatorType[OperatorType["COALESCING"] = 3] = "COALESCING";
    OperatorType[OperatorType["OR"] = 4] = "OR";
    OperatorType[OperatorType["AND"] = 5] = "AND";
    OperatorType[OperatorType["EQUALITY"] = 6] = "EQUALITY";
    OperatorType[OperatorType["RELATIONAL"] = 7] = "RELATIONAL";
    OperatorType[OperatorType["SHIFT"] = 8] = "SHIFT";
    OperatorType[OperatorType["ADDITION"] = 9] = "ADDITION";
    OperatorType[OperatorType["MULTIPLICATION"] = 10] = "MULTIPLICATION";
    OperatorType[OperatorType["POWER"] = 11] = "POWER";
    OperatorType[OperatorType["UNARY"] = 12] = "UNARY";
})(OperatorType = exports.OperatorType || (exports.OperatorType = {}));
var SyntaxType;
(function (SyntaxType) {
    SyntaxType[SyntaxType["EMPTY"] = 0] = "EMPTY";
    SyntaxType[SyntaxType["PATH"] = 1] = "PATH";
    SyntaxType[SyntaxType["PATH_OPTIONS"] = 2] = "PATH_OPTIONS";
    SyntaxType[SyntaxType["SELECTOR"] = 3] = "SELECTOR";
    SyntaxType[SyntaxType["LAMBDA_ARG"] = 4] = "LAMBDA_ARG";
    SyntaxType[SyntaxType["LITERAL"] = 5] = "LITERAL";
    SyntaxType[SyntaxType["LOGICAL_COALESCE_EXPR"] = 6] = "LOGICAL_COALESCE_EXPR";
    SyntaxType[SyntaxType["LOGICAL_OR_EXPR"] = 7] = "LOGICAL_OR_EXPR";
    SyntaxType[SyntaxType["LOGICAL_AND_EXPR"] = 8] = "LOGICAL_AND_EXPR";
    SyntaxType[SyntaxType["COMPARISON_EXPR"] = 9] = "COMPARISON_EXPR";
    SyntaxType[SyntaxType["IN_EXPR"] = 10] = "IN_EXPR";
    SyntaxType[SyntaxType["MATH_EXPR"] = 11] = "MATH_EXPR";
    SyntaxType[SyntaxType["UNARY_EXPR"] = 12] = "UNARY_EXPR";
    SyntaxType[SyntaxType["SPREAD_EXPR"] = 13] = "SPREAD_EXPR";
    SyntaxType[SyntaxType["CONDITIONAL_EXPR"] = 14] = "CONDITIONAL_EXPR";
    SyntaxType[SyntaxType["ARRAY_INDEX_FILTER_EXPR"] = 15] = "ARRAY_INDEX_FILTER_EXPR";
    SyntaxType[SyntaxType["OBJECT_INDEX_FILTER_EXPR"] = 16] = "OBJECT_INDEX_FILTER_EXPR";
    SyntaxType[SyntaxType["RANGE_FILTER_EXPR"] = 17] = "RANGE_FILTER_EXPR";
    SyntaxType[SyntaxType["OBJECT_FILTER_EXPR"] = 18] = "OBJECT_FILTER_EXPR";
    SyntaxType[SyntaxType["ARRAY_FILTER_EXPR"] = 19] = "ARRAY_FILTER_EXPR";
    SyntaxType[SyntaxType["DEFINITION_EXPR"] = 20] = "DEFINITION_EXPR";
    SyntaxType[SyntaxType["ASSIGNMENT_EXPR"] = 21] = "ASSIGNMENT_EXPR";
    SyntaxType[SyntaxType["OBJECT_PROP_EXPR"] = 22] = "OBJECT_PROP_EXPR";
    SyntaxType[SyntaxType["OBJECT_EXPR"] = 23] = "OBJECT_EXPR";
    SyntaxType[SyntaxType["ARRAY_EXPR"] = 24] = "ARRAY_EXPR";
    SyntaxType[SyntaxType["BLOCK_EXPR"] = 25] = "BLOCK_EXPR";
    SyntaxType[SyntaxType["FUNCTION_EXPR"] = 26] = "FUNCTION_EXPR";
    SyntaxType[SyntaxType["FUNCTION_CALL_ARG"] = 27] = "FUNCTION_CALL_ARG";
    SyntaxType[SyntaxType["FUNCTION_CALL_EXPR"] = 28] = "FUNCTION_CALL_EXPR";
    SyntaxType[SyntaxType["STATEMENTS_EXPR"] = 29] = "STATEMENTS_EXPR";
})(SyntaxType = exports.SyntaxType || (exports.SyntaxType = {}));
var PathType;
(function (PathType) {
    PathType[PathType["SIMPLE"] = 0] = "SIMPLE";
    PathType[PathType["RICH"] = 1] = "RICH";
})(PathType = exports.PathType || (exports.PathType = {}));
