"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CommonUtils = void 0;
const types_1 = require("./types");
class CommonUtils {
    static toArray(val) {
        if (val === undefined || val === null) {
            return undefined;
        }
        return Array.isArray(val) ? val : [val];
    }
    static getLastElement(arr) {
        if (!arr.length) {
            return undefined;
        }
        return arr[arr.length - 1];
    }
    static convertToStatementsExpr(...expressions) {
        return {
            type: types_1.SyntaxType.STATEMENTS_EXPR,
            statements: expressions,
        };
    }
    static CreateAsyncFunction(...args) {
        return async function () { }.constructor(...args);
    }
    static escapeStr(s) {
        if (typeof s !== 'string') {
            return '';
        }
        return `'${s.replace(/\\/g, '\\\\').replace(/'/g, "\\'")}'`;
    }
}
exports.CommonUtils = CommonUtils;
